<html lang="en">
<head>
<title>Parsing Optimization - Semantic Manual</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Semantic Manual">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="up" href="Installation_002fBasic-Configuration.html#Installation_002fBasic-Configuration" title="Installation/Basic Configuration">
<link rel="prev" href="Search-Optimization.html#Search-Optimization" title="Search Optimization">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<!--
This manual documents Semantic, a new intrastructure for parser
based text analysis for Emacs.

Copyright (C) 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2007 Eric M. Ludlam
Copyright (C) 2001, 2002, 2003, 2005 David Ponce
Copyright (C) 2002, 2003 Richard Y. Kim

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU Free Documentation License,
     Version 1.1 or any later version published by the Free Software
     Foundation; with the Invariant Sections being list their titles,
     with the Front-Cover Texts being list, and with the Back-Cover
     Texts being list.  A copy of the license is included in the
     section entitled ``GNU Free Documentation License''.
-->
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Parsing-Optimization"></a>
Previous:&nbsp;<a rel="previous" accesskey="p" href="Search-Optimization.html#Search-Optimization">Search Optimization</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="Installation_002fBasic-Configuration.html#Installation_002fBasic-Configuration">Installation/Basic Configuration</a>
<hr>
</div>

<h3 class="section">2.3 Parsing Optimization</h3>

<p>The semantic parsers generate the tags that form the basis of all the
semantic based tools, such as browsers and completion.  Keeping those
tags up to date can have performance implications.

<p>Here are some common tasks you may be interested in:

<h4 class="subsection">2.3.1 Don't parse certain buffers</h4>

<p>You can inhibit parsing using the <code>semantic-inhibit-functions</code>
variable.

<div class="defun">
&mdash; Variable: <b>semantic-inhibit-functions</b><var><a name="index-semantic_002dinhibit_002dfunctions-6"></a></var><br>
<blockquote><p><a name="semantic_002dinhibit_002dfunctions"></a>
List of functions to call with no arguments before to setup Semantic. 
If any of these functions returns non-<code>nil</code>, the current buffer is not
setup to use Semantic. 
</p></blockquote></div>

<p>You could have this inihibit parsing in very large files, or files
which case particular problems to semantic.

<h4 class="subsection">2.3.2 Parsing in idle time</h4>

<p>Tags are usually kept up to date when Emacs is idle
<a href="../semantic_002duser/Idle-Scheduler.html#g_t_0028semantic_002duser_0029Idle-Scheduler">(semantic-user)Idle Scheduler</a>.  The semantic's idle-scheduler
automatically updates the tags in various buffers before executing
specific idle modes, such as summary mode.

<p>You might choose to tune the scheduler with some code like this in
your <samp><span class="file">.emacs</span></samp> file:

<pre class="example">     ;; Increase the delay before activation
     (setq semantic-idle-scheduler-idle-time 10)
     ;; Don't reparse really big buffers.
     (setq semantic-idle-scheduler-max-buffer-size 100000)
</pre>
</body></html>

